#!/usr/bin/env ruby
#
# httpd-tcpwrap.rb -- a sample of address base access control with
#                     Ruby/TCPWrapper

require 'webrick'
require 'tcpwrap'

base = File::expand_path(File::dirname(__FILE__))
TCPWrapper::hosts_allow = File::join(base, "conf/hosts.allow")
TCPWrapper::hosts_deny = File::join(base, "conf/hosts.deny")

s = WEBrick::HTTPServer::new(
  :Port           => 10080,
  :DocumentRoot   => File::join(base, "htdocs"),
  :AcceptCallback => lambda{|sock|
    begin
      addr = sock.peeraddr
      TCPWrapper::hosts_ctl("httpd", addr[2], addr[3], nil)
    rescue => ex
      message = format("access denied:%s:%s", addr[2], addr[3])
      raise WEBrick::ServerError, message
    end
  }
)
trap("INT"){ s.shutdown }
s.start
