#!/usr/bin/env ruby
$:.unshift('../../lib')

require 'webrick'
require 'getopts'

getopts "", 'r:', 'p:8808'

dir = File::dirname(File::expand_path(__FILE__))
accesslog = WEBrick::BasicLog::new(File::join(dir, "var", "accesslog"))
referer   = WEBrick::BasicLog::new(File::join(dir, "var", "referer"))
agent     = WEBrick::BasicLog::new(File::join(dir, "var", "agent"))
combined  = WEBrick::BasicLog::new($stderr)

s = WEBrick::HTTPServer.new(
  :BindAddress    => "0.0.0.0",
  :Port           => $OPT_p.to_i,
  :DocumentRoot   => $OPT_r || File::join(dir, "htdocs"),
  :Logger         => WEBrick::Log::new($stderr, WEBrick::Log::DEBUG),
  :AccessLog      => [
     [ accesslog, WEBrick::AccessLog::COMMON_LOG_FORMAT   ],
     [ referer,   WEBrick::AccessLog::REFERER_LOG_FORMAT  ],
     [ agent,     WEBrick::AccessLog::AGENT_LOG_FORMAT    ],
     [ combined,  WEBrick::AccessLog::COMBINED_LOG_FORMAT ],
  ],
  :CGIPathEnv     => ENV['PATH']  # Especially for Cygwin
)
trap(:INT){ s.shutdown }
s.start
