#!/usr/bin/env ruby

require 'getopts'
require 'fileutils'
require 'ndtp'

getopts(nil, "d:./gaiji")
gaiji_root = $OPT_d

ndtp = NDTP.new(:Host => ARGV[0] || "localhost",
                :Port => ARGV[1] || "ndtp")
ndtp.dict_list.each{|number, dict, dict_name|
  ndtp.select_dict(number)
  size = ndtp.get_gaiji_size.first
  next unless size

  dir = File::join(gaiji_root, dict)
  FileUtils::makedirs(dir) unless FileTest::directory?(dir)

  ndtp.set_gaiji_size(size)
  ndtp.get_gaiji_all{|gaiji_id, data|
    xbm = File::join(dir, gaiji_id+".xbm")
    png = File::join(dir, gaiji_id+".png")
    puts "=> #{xbm}"
    open(xbm, "w"){|io| io.write(data) }
    system("convert #{xbm} #{png}")
  }
}
